Bug 1129850 - Perl debugger commands that depend on Padwalker no longer work
Summary: Perl debugger commands that depend on Padwalker no longer work
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: perl
Version: 21
Hardware: x86_64
OS: Linux
unspecified
high
Target Milestone: ---
Assignee: Jitka Plesnikova
QA Contact: Fedora Extras Quality Assurance
URL: http://nntp.perl.org/group/perl.perl5...
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2014-08-13 19:17 UTC by Alan Olsen
Modified: 2015-10-04 23:20 UTC (History)
9 users (show)

Fixed In Version: perl-5.22.0-344.fc23 perl-5.20.3-328.fc22 perl-5.18.4-310.fc21
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2015-10-03 21:14:14 UTC


Attachments (Terms of Use)
An example of how it should work. (3.29 KB, text/plain)
2014-08-13 19:29 UTC, Alan Olsen
no flags Details
An example how it works now. (906 bytes, text/plain)
2014-08-13 19:30 UTC, Alan Olsen
no flags Details
Fix for 'y' command in debugger (1.08 KB, patch)
2014-08-15 06:28 UTC, Alan Olsen
no flags Details | Diff

Description Alan Olsen 2014-08-13 19:17:31 UTC
Description of problem:

When using the Perl command line debugger the "y" and "X" commands no longer work. (They fail silently.)

Version-Release number of selected component (if applicable):

perl-5.18.2-289.fc20
perl-PadWalker-1.98-1.fc20.x86_64

How reproducible:
Every time.

Steps to Reproduce:
1. Debug a test program with "perl -d testprog.pl
2. Use "n" and enter a few lines until a variable you want to examine is loaded.
3. Use "y" or "X" on that variable.

Actual results:

Nothing returned.

Expected results:

The contents of the variable should be displayed.

Additional info:

The "p" command will print a variable, it is very narrow in scope. It will not display the contents of an entire hash variable like "X" or "y" will. ("y" shows the contents of the variable for all types in the current package. "X" does the same for global variables. Neither work at this point.

Comment 1 Alan Olsen 2014-08-13 19:29:09 UTC
Created attachment 926559 [details]
An example of how it should work.

Comment 2 Alan Olsen 2014-08-13 19:30:28 UTC
Created attachment 926560 [details]
An example how it works now.

This is what it does now. Notice nothing is returned by the y or X command.

Comment 3 Petr Pisar 2014-08-14 06:34:33 UTC
The X does not work even in CentoOS 5. The perl debugger is doomed. It has been broken for ages. Ask upstream for help <https://rt.perl.org//Public/>.

Comment 4 Alan Olsen 2014-08-14 16:28:53 UTC
(In reply to Petr Pisar from comment #3)
> The X does not work even in CentoOS 5. The perl debugger is doomed. It has
> been broken for ages. Ask upstream for help <https://rt.perl.org//Public/>.

The example that I posted was from CentOS 5.10. It works fine there.

The question is *why* it is broken.

I will talk to upstream and see if they have ideas as to what is going wrong. I will also build it from scratch and see if that works.

Comment 5 Alan Olsen 2014-08-15 06:28:40 UTC
Created attachment 926984 [details]
Fix for 'y' command in debugger

This is a fix for the problem. It will conflict on the version number, but that is not important. The second part of the patch fixes the problem. (It is an off by one error.)

Comment 6 Petr Pisar 2014-08-15 07:50:20 UTC
(In reply to Alan Olsen from comment #4)
> (In reply to Petr Pisar from comment #3)
> > The X does not work even in CentoOS 5. The perl debugger is doomed. It has
> > been broken for ages. Ask upstream for help <https://rt.perl.org//Public/>.
> 
> The example that I posted was from CentOS 5.10. It works fine there.
> 
The example showed only "y". I tested in RHEL-5.11 the "X" too. "y" worked for me, "X" didn't.

I even tested RHEL-6 (perl-5.10.1) and Fedora 19 and Perl development tree (5.21.x) and both commands are broken there too.

> I will talk to upstream and see if they have ideas as to what is going
> wrong.

When you do that, post the link here please.

Comment 7 Fedora End Of Life 2015-05-29 12:37:51 UTC
This message is a reminder that Fedora 20 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 20. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '20'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 20 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 8 Fedora Update System 2015-09-24 09:33:48 UTC
perl-5.20.3-328.fc22 has been submitted as an update to Fedora 22. https://bodhi.fedoraproject.org/updates/FEDORA-2015-16582

Comment 9 Fedora Update System 2015-09-25 06:17:22 UTC
perl-5.18.4-310.fc21 has been submitted as an update to Fedora 21. https://bodhi.fedoraproject.org/updates/FEDORA-2015-b4c6dd8cd3

Comment 10 Fedora Update System 2015-09-27 00:39:06 UTC
perl-5.20.3-328.fc22 has been pushed to the Fedora 22 testing repository. If problems still persist, please make note of it in this bug report.
If you want to test the update, you can install it with
$ su -c 'dnf --enablerepo=updates-testing update perl'
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-16582

Comment 11 Fedora Update System 2015-09-27 02:21:59 UTC
perl-5.18.4-310.fc21 has been pushed to the Fedora 21 testing repository. If problems still persist, please make note of it in this bug report.
If you want to test the update, you can install it with
$ su -c 'dnf --enablerepo=updates-testing update perl'
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-b4c6dd8cd3

Comment 12 Fedora Update System 2015-10-03 21:14:11 UTC
perl-5.20.3-328.fc22 has been pushed to the Fedora 22 stable repository. If problems still persist, please make note of it in this bug report.

Comment 13 Fedora Update System 2015-10-04 23:20:26 UTC
perl-5.18.4-310.fc21 has been pushed to the Fedora 21 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.